

#property indicator_chart_window
#property  indicator_buffers 8
extern color FiboColour=Black;
extern bool  Higher_To_Lower = true;    
extern color TrendUpColor = Green;
extern color TrendDownColor = Red;


double         SwingHigh, SwingLow;
double         high, low, Entry, RetraceSellLevel, StopTradingHighLevel, StopTradingLowLevel;
double         TP1, TP2, TP3, RetraceSellTP;


int init()
  {
   return(0);
  }

int deinit()
  {

   ObjectDelete("Fibo");
  
   Comment(" ");

   return(0);
  }

 void GetSwing()
{

   SwingHigh = iHigh(Symbol(),PERIOD_D1,0);
   
   SwingLow = iLow(Symbol(),PERIOD_D1,0);
      
   CalculateTradeLevels();
  
   
}
  
void CalculateTradeLevels()
{
   double extent = SwingHigh - SwingLow;
   
   high = SwingHigh;
   low = SwingLow;
   
   if (Higher_To_Lower)
      {
   Entry = NormalizeDouble(SwingLow + (extent * 1.41 / 100), Digits); 
   TP1 = NormalizeDouble(SwingLow + (extent * 28.2 / 100), Digits); 
   TP2 = NormalizeDouble(SwingLow + (extent * 41.4 / 100), Digits); 
   TP3 = NormalizeDouble(SwingLow + (extent * 64.2 / 100), Digits); 
   }else{
   
   Entry = NormalizeDouble(SwingHigh - (extent * 1.41 / 100), Digits); 
   TP1 = NormalizeDouble(SwingHigh - (extent * 28.2 / 100), Digits); 
   TP2 = NormalizeDouble(SwingHigh - (extent * 41.4 / 100), Digits); 
   TP3 = NormalizeDouble(SwingHigh - (extent * 64.2 / 100), Digits); 
   }
   
   //StopTradingHighLevel = NormalizeDouble(SwingHigh + extent, Digits); 
   //StopTradingLowLevel = NormalizeDouble(SwingLow - extent, Digits); 
   //RetraceSellTP = TP3;
   
   
   if(Higher_To_Lower)
   {
      WindowRedraw();
      FiboColour = TrendDownColor;
      Higher_To_Lower = true;
   }
   else{
      WindowRedraw();
      FiboColour = TrendUpColor;
      Higher_To_Lower = false;
   }
   
   
   
   
}  
   
void DrawFib()
{
      double HighPrice, LowPrice;
      datetime OpenTime, CloseTime;
      
      
      HighPrice = SwingHigh;
      OpenTime = iTime(NULL, PERIOD_D1, 0);
      LowPrice = SwingLow;
      CloseTime = iTime(NULL, PERIOD_D1, 0);
      
      if (Higher_To_Lower)
      {         
      ObjectCreate("Fibo",OBJ_FIBO,0,OpenTime,HighPrice,CloseTime,LowPrice);
      ObjectSet("Fibo", OBJPROP_COLOR, FiboColour);
      ObjectSet("Fibo", OBJPROP_LEVELCOLOR, FiboColour);
      ObjectSet("Fibo", OBJPROP_WIDTH, 1);
      ObjectSet("Fibo", OBJPROP_FIBOLEVELS, 6);     
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+0, 0);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+1, 0.141);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+2, 0.282);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+3, 0.414);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+4, 0.642);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+5, 1);
      
      
      ObjectSetFiboDescription("Fibo", 0, "  %$ -" + " (0)");
      ObjectSetFiboDescription("Fibo", 1, "  %$ -" + " (1.41)");
      ObjectSetFiboDescription("Fibo", 2, "  %$ -" + " (2.82)");
      ObjectSetFiboDescription("Fibo", 3, "  %$ -" + " (41.4)");
      ObjectSetFiboDescription("Fibo", 4, "  %$ -" + " (64.2)");
      ObjectSetFiboDescription("Fibo", 5, "  %$ -" + " (100)");
      
      
      
  }else{
  
      ObjectCreate("Fibo",OBJ_FIBO,0,OpenTime,HighPrice,CloseTime,LowPrice);
      ObjectSet("Fibo", OBJPROP_COLOR, FiboColour);
      ObjectSet("Fibo", OBJPROP_LEVELCOLOR, FiboColour);
      ObjectSet("Fibo", OBJPROP_WIDTH, 1);
      ObjectSet("Fibo", OBJPROP_FIBOLEVELS, 6);     
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+0, 0);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+1, 0.141);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+2, 0.282);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+3, 0.414);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+4, 0.642);
      ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+5, 1);
      ObjectSetFiboDescription("Fibo", 5, "  %$ -" + " (0)");
      ObjectSetFiboDescription("Fibo", 4, "  %$ -" + " (1.41)");
      ObjectSetFiboDescription("Fibo", 3, "  %$ -" + " (2.82)");
      ObjectSetFiboDescription("Fibo", 2, "  %$ -" + " (41.4)");
      ObjectSetFiboDescription("Fibo", 1, "  %$ -" + " (64.2)");
      ObjectSetFiboDescription("Fibo", 0, "  %$ -" + " (100)");
      
      
      
  }   
}




int start()

  { 
  GetSwing();
  CalculateTradeLevels(); 
  DrawFib(); 
  
  }
  
  